<!DOCTYPE html>
<html lang="en" xmlns="http://www.w3.org/1999/xhtml" xmlns:th="http://www.thymeleaf.org"
    xmlns:sec="http://www.w3.org/1999/xhtml">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="/css/bootstrap.min.css">
    <script src="/js/jquery-3.7.1.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.5.2/css/fontawesome.min.css"
        integrity="sha512-UuQ/zJlbMVAw/UU8vVBhnI4op+/tFOpQZVT+FormmIEhRSCnJWyHiBbEVgM4Uztsht41f3FzVWgLuwzUqOObKw=="
        crossorigin="anonymous" referrerpolicy="no-referrer" />

    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.5.2/css/solid.min.css"
        integrity="sha512-Hp+WwK4QdKZk9/W0ViDvLunYjFrGJmNDt6sCflZNkjgvNq9mY+0tMbd6tWMiAlcf1OQyqL4gn2rYp7UsfssZPA=="
        crossorigin="anonymous" referrerpolicy="no-referrer" />

    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.5.2/css/brands.min.css"
        integrity="sha512-DJLNx+VLY4aEiEQFjiawXaiceujj5GA7lIY8CHCIGQCBPfsEG0nGz1edb4Jvw1LR7q031zS5PpPqFuPA8ihlRA=="
        crossorigin="anonymous" referrerpolicy="no-referrer" />
    <style>
        .baner {
            height: 200px;
            background-color: rgb(200 208 215);
        }

        .card-img-top {
            max-width: 100%;
            max-height: 260px;
            object-fit: contain;
        }

        .toast-container {
            position: fixed;
            top: 20px;
            left: 50%;
            transform: translateX(-50%);
            z-index: 1055;
        }
    </style>
</head>

<body>
    <div class="container">

        <div class="col-12">
            <div class="row  baner">

                <div class="col-8 d-flex align-items-center">
                    <div class="row">
                        <h1>Products</h1>
                        <p>All the available products in our store</p>
                    </div>
                </div>
                <div class="col-4 text-end">
                    <br><br>
                    <a th:href="@{/cart/view}" type="button" class="btn btn-light"> <i
                            class="fa-solid fa-cart-shopping fa-flip-horizontal"></i> view cart</a>
                </div>
            </div>

        </div>
        <div class="container mt-4">
            <div class="row justify-content-center">
                <div class="col-12">
                    <div class="row " id="products">
                        <div th:each="item : ${listProduct}" th:if="${listProduct}"
                            class="col-12 col-sm-6 col-md-4 col-lg-3 mb-3 ">
                            <div class="card h-100">
                                <input type="hidden" th:value="${item.id}" id="idProduct">
                                <h3 class="card-title p-2" th:text="${item.name}">Card title</h3>
                                <img th:if="${item.images.size() > 0}"
                                    th:src="'data:image/png;base64,' + ${item.images[0]}" class="card-img-top"
                                    alt="...">

                                <div class="card-body d-flex flex-column">
                                    <p th:if="${#strings.length(item.description) <= 100}" class="card-text"
                                        th:utext="${item.description}"></p>
                                    <p class="card-text" th:if="${#strings.length(item.description) > 100}" th:utext="${#strings.substring(item.description, 
                                            0, 100)+' ...'}">
                                    </p>

                                    <p class="card-text mt-auto" th:text="${item.price + ' USD'}" id="priceProduct"></p>
                                    <p class="card-text" id="quantityInStock" th:text="${item.quantityInStock}"><span>
                                            units in stock</span></p>
                                    <div class="row ">
                                        <a th:href="@{/product/detail/{id}(id=${item.id})}"
                                            class="col btn btn-primary m-2 p-2"><i
                                                class="fa-sharp fa-regular fa-circle-info"></i> Details</a>
                                        <a style="color: #fff;" href="" class="col btn btn-warning m-2 p-2"><i
                                                class="fa-solid fa-cart-shopping fa-flip-horizontal"></i> Order Now</a>
                                    </div>
                                    <div class="row" sec:authorize="hasRole('ROLE_ADMIN')">
                                        <a style="color: #fff;" th:href="@{'/product/edit/' + ${item.id}}"
                                            class="col btn btn-primary m-2 p-2">
                                            <i class="fa-solid fa-pencil"></i> Edit
                                        </a>
                                        <a th:href="@{'/product/delete/' + ${item.id}}"
                                            onclick="return confirm('Bạn có chắc chắn muốn xóa không?')"
                                            class="col btn btn-danger m-2 p-2">
                                            <i class="fa-regular fa-trash-can"></i> Delete
                                        </a>
                                    </div>

                                </div>
                            </div>
                        </div>


                    </div>
                    <p id="endOfPage"></p>
                </div>
            </div>
        </div>
        <!-- Flexbox container for aligning the toasts -->
        <div aria-live="polite" aria-atomic="true" class="toast-container">

            <!-- Then put toasts within -->
            <div class="toast" id="myToast" role="alert" aria-live="assertive" aria-atomic="true"
                data-bs-autohide="true" data-bs-delay="3000">
                <div class="toast-body">
                </div>
            </div>
        </div>

    </div>
    <script src="/js/bootstrap.min.js"></script>
    <script src="/js/cart.js"></script>
    <script>

        var currentPage = 1;
        var observer = new IntersectionObserver(loadMoreProducts, {
            rootMargin: '0px',
            threshold: 1.0
        });

        var endOfPage = document.getElementById('endOfPage');
        observer.observe(endOfPage);

        function loadMoreProducts(entries) {
            if (entries[0].isIntersecting) {
                console.log("tải thêm sản phẩm ")
                $.ajax({
                    url: "/load-more-product",
                    data: {
                        page: ++currentPage
                    },
                    success: function (data) {
                        displayProducts(data);
                        if (data.last) {
                            observer.disconnect();
                        }
                    }
                });
            }
        }

        function displayProducts(data) {
            var productsContainer = $("#products");
            $.each(data.content, function (index, product) {
                var description = product.description;
                if (description.length > 100) {
                    description = description.substring(0, 100) + "...";
                }
                var productCard = `
            <div class="col-12 col-sm-6 col-md-4 col-lg-3 mb-3">
                <div class="card h-100">
                    <h3 class="card-title p-2">${product.name}</h3>
                    <img src="${product.imageUrl}" class="card-img-top" alt="...">
                    <div class="card-body d-flex flex-column">
                        <p class="card-text">${description}</p>
                        <p class="card-text mt-auto ">${product.price} USD</p>
                        <p class="card-text" id="quantityInStock">${product.quantityInStock} <span>units in stock</span></p>
                        <div class="row ">
                            <a href="" class="col btn btn-primary m-2 p-2"><i class="fa-sharp fa-regular fa-circle-info"></i> Details</a>
                            <a style="color: #fff;" href="" class="col btn btn-warning m-2 p-2"><i class="fa-solid fa-cart-shopping fa-flip-horizontal"></i> Order Now</a>
                        </div>
                    </div>
                </div>
            </div>
        `;
                productsContainer.append(productCard);
            });
        }

        $('#products .card').each(function () {
            const card = $(this);
            const orderBtn = card.find('.btn-warning');

            orderBtn.on('click', function (e) {
                e.preventDefault();

                const product = {
                    id: card.find('#idProduct').val(),
                    name: card.find('.card-title').text().trim(),
                    price: parseFloat(card.find('#priceProduct:contains("USD")').text().replace(' USD', '').trim()),
                    quantity: 1,
                };

                let quantityInStock = parseInt(card.find('#quantityInStock').text());
               
                if (quantityInStock > 0) {
                    addToCart(product);
                    showToast(product.name)
                } else {
                    showToastFail(product.name)
                }
            });
        });



    </script>
</body>

</html>